Module javafx.controls
Package javafx.scene.control.cell

## Class TextFieldTreeCell<T>

- java.lang.Object
- - javafx.scene.Node
  - - javafx.scene.Parent
    - - javafx.scene.layout.Region
      - - javafx.scene.control.Control
        - - javafx.scene.control.Labeled
          - - javafx.scene.control.Cell<T>
            - - javafx.scene.control.IndexedCell<T>
              - - javafx.scene.control.TreeCell<T>
                - - javafx.scene.control.cell.TextFieldTreeCell<T>

- Type Parameters:
    `T` - The type of the elements contained within the TreeView.
  All Implemented Interfaces:
    `Styleable`, `EventTarget`, `Skinnable`

      public class TextFieldTreeCell<T>
      extends TreeCell<T>

  A class containing a `TreeCell` implementation that draws a `TextField` node inside the cell.

  By default, the TextFieldTreeCell is rendered as a `Label` when not being edited, and as a TextField when in editing mode. The TextField will, by default, stretch to fill the entire tree cell.

  Since:
    JavaFX 2.2

- - ### Property Summary

    Properties
    Type | Property | Description
    --- | --- | ---
    `ObjectProperty<StringConverter<T>>` | `converter` | The `StringConverter` property.

    - ### Properties inherited from class javafx.scene.control.TreeCell

      `disclosureNode, treeItem, treeView`

    - ### Properties inherited from class javafx.scene.control.IndexedCell

      `index`

    - ### Properties inherited from class javafx.scene.control.Cell

      `editable, editing, empty, item, selected`

    - ### Properties inherited from class javafx.scene.control.Labeled

      `alignment, contentDisplay, ellipsisString, font, graphic, graphicTextGap, labelPadding, lineSpacing, mnemonicParsing, textAlignment, textFill, textOverrun, text, underline, wrapText`

    - ### Properties inherited from class javafx.scene.control.Control

      `contextMenu, skin, tooltip`

    - ### Properties inherited from class javafx.scene.layout.Region

      `background, border, cacheShape, centerShape, height, insets, maxHeight, maxWidth, minHeight, minWidth, opaqueInsets, padding, prefHeight, prefWidth, scaleShape, shape, snapToPixel, width`

    - ### Properties inherited from class javafx.scene.Parent

      `needsLayout`

    - ### Properties inherited from class javafx.scene.Node

      `accessibleHelp, accessibleRoleDescription, accessibleRole, accessibleText, blendMode, boundsInLocal, boundsInParent, cacheHint, cache, clip, cursor, depthTest, disabled, disable, effectiveNodeOrientation, effect, eventDispatcher, focused, focusTraversable, hover, id, inputMethodRequests, layoutBounds, layoutX, layoutY, localToParentTransform, localToSceneTransform, managed, mouseTransparent, nodeOrientation, onContextMenuRequested, onDragDetected, onDragDone, onDragDropped, onDragEntered, onDragExited, onDragOver, onInputMethodTextChanged, onKeyPressed, onKeyReleased, onKeyTyped, onMouseClicked, onMouseDragEntered, onMouseDragExited, onMouseDragged, onMouseDragOver, onMouseDragReleased, onMouseEntered, onMouseExited, onMouseMoved, onMousePressed, onMouseReleased, onRotate, onRotationFinished, onRotationStarted, onScrollFinished, onScroll, onScrollStarted, onSwipeDown, onSwipeLeft, onSwipeRight, onSwipeUp, onTouchMoved, onTouchPressed, onTouchReleased, onTouchStationary, onZoomFinished, onZoom, onZoomStarted, opacity, parent, pickOnBounds, pressed, rotate, rotationAxis, scaleX, scaleY, scaleZ, scene, style, translateX, translateY, translateZ, viewOrder, visible`

  - ### Field Summary

    - ### Fields inherited from class javafx.scene.layout.Region

      `USE_COMPUTED_SIZE, USE_PREF_SIZE`

    - ### Fields inherited from class javafx.scene.Node

      `BASELINE_OFFSET_SAME_AS_HEIGHT`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `TextFieldTreeCell()` | Creates a default TextFieldTreeCell with a null converter.
    `TextFieldTreeCell​(StringConverter<T> converter)` | Creates a TextFieldTreeCell that provides a `TextField` when put into editing mode that allows editing of the cell content.

  - ### Method Summary

    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `cancelEdit()` | Call this function to transition from an editing state into a non-editing state, without saving any user input.
    `ObjectProperty<StringConverter<T>>` | `converterProperty()` | The `StringConverter` property.
    `static Callback<TreeView<String>,​TreeCell<String>>` | `forTreeView()` | Provides a `TextField` that allows editing of the cell content when the cell is double-clicked, or when `TreeView.edit(javafx.scene.control.TreeItem)` is called.
    `static <T> Callback<TreeView<T>,​TreeCell<T>>` | `forTreeView​(StringConverter<T> converter)` | Provides a `TextField` that allows editing of the cell content when the cell is double-clicked, or when `TreeView.edit(javafx.scene.control.TreeItem)` is called.
    `StringConverter<T>` | `getConverter()` | Returns the `StringConverter` used in this cell.
    `void` | `setConverter​(StringConverter<T> value)` | Sets the `StringConverter` to be used in this cell.
    `void` | `startEdit()` | Call this function to transition from a non-editing state into an editing state, if the cell is editable.
    `void` | `updateItem​(T item, boolean empty)` | The updateItem method should not be called by developers, but it is the best method for developers to override to allow for them to customise the visuals of the cell.

    - ### Methods inherited from class javafx.scene.control.TreeCell

      `commitEdit, createDefaultSkin, disclosureNodeProperty, executeAccessibleAction, getDisclosureNode, getTreeItem, getTreeView, queryAccessibleAttribute, setDisclosureNode, treeItemProperty, treeViewProperty, updateTreeItem, updateTreeView`

    - ### Methods inherited from class javafx.scene.control.IndexedCell

      `getIndex, indexProperty, updateIndex`

    - ### Methods inherited from class javafx.scene.control.Cell

      `editableProperty, editingProperty, emptyProperty, getInitialFocusTraversable, getItem, isEditable, isEditing, isEmpty, isItemChanged, isSelected, itemProperty, layoutChildren, selectedProperty, setEditable, setItem, updateSelected`

    - ### Methods inherited from class javafx.scene.control.Labeled

      `alignmentProperty, contentDisplayProperty, ellipsisStringProperty, fontProperty, getAlignment, getClassCssMetaData, getContentBias, getContentDisplay, getControlCssMetaData, getEllipsisString, getFont, getGraphic, getGraphicTextGap, getInitialAlignment, getLabelPadding, getLineSpacing, getText, getTextAlignment, getTextFill, getTextOverrun, graphicProperty, graphicTextGapProperty, isMnemonicParsing, isUnderline, isWrapText, labelPaddingProperty, lineSpacingProperty, mnemonicParsingProperty, setAlignment, setContentDisplay, setEllipsisString, setFont, setGraphic, setGraphicTextGap, setLineSpacing, setMnemonicParsing, setText, setTextAlignment, setTextFill, setTextOverrun, setUnderline, setWrapText, textAlignmentProperty, textFillProperty, textOverrunProperty, textProperty, toString, underlineProperty, wrapTextProperty`

    - ### Methods inherited from class javafx.scene.control.Control

      `computeMaxHeight, computeMaxWidth, computeMinHeight, computeMinWidth, computePrefHeight, computePrefWidth, contextMenuProperty, getBaselineOffset, getContextMenu, getCssMetaData, getSkin, getTooltip, isResizable, setContextMenu, setSkin, setTooltip, skinProperty, tooltipProperty`

    - ### Methods inherited from class javafx.scene.layout.Region

      `backgroundProperty, borderProperty, cacheShapeProperty, centerShapeProperty, getBackground, getBorder, getHeight, getInsets, getMaxHeight, getMaxWidth, getMinHeight, getMinWidth, getOpaqueInsets, getPadding, getPrefHeight, getPrefWidth, getShape, getUserAgentStylesheet, getWidth, heightProperty, insetsProperty, isCacheShape, isCenterShape, isScaleShape, isSnapToPixel, layoutInArea, layoutInArea, layoutInArea, layoutInArea, maxHeight, maxHeightProperty, maxWidth, maxWidthProperty, minHeight, minHeightProperty, minWidth, minWidthProperty, opaqueInsetsProperty, paddingProperty, positionInArea, positionInArea, prefHeight, prefHeightProperty, prefWidth, prefWidthProperty, resize, scaleShapeProperty, setBackground, setBorder, setCacheShape, setCenterShape, setHeight, setMaxHeight, setMaxSize, setMaxWidth, setMinHeight, setMinSize, setMinWidth, setOpaqueInsets, setPadding, setPrefHeight, setPrefSize, setPrefWidth, setScaleShape, setShape, setSnapToPixel, setWidth, shapeProperty, snappedBottomInset, snappedLeftInset, snappedRightInset, snappedTopInset, snapPosition, snapPositionX, snapPositionY, snapSize, snapSizeX, snapSizeY, snapSpace, snapSpaceX, snapSpaceY, snapToPixelProperty, widthProperty`

    - ### Methods inherited from class javafx.scene.Parent

      `getChildren, getChildrenUnmodifiable, getManagedChildren, getStylesheets, isNeedsLayout, layout, lookup, needsLayoutProperty, requestLayout, requestParentLayout, setNeedsLayout, updateBounds`

    - ### Methods inherited from class javafx.scene.Node

      `accessibleHelpProperty, accessibleRoleDescriptionProperty, accessibleRoleProperty, accessibleTextProperty, addEventFilter, addEventHandler, applyCss, autosize, blendModeProperty, boundsInLocalProperty, boundsInParentProperty, buildEventDispatchChain, cacheHintProperty, cacheProperty, clipProperty, computeAreaInScreen, contains, contains, cursorProperty, depthTestProperty, disabledProperty, disableProperty, effectiveNodeOrientationProperty, effectProperty, eventDispatcherProperty, fireEvent, focusedProperty, focusTraversableProperty, getAccessibleHelp, getAccessibleRole, getAccessibleRoleDescription, getAccessibleText, getBlendMode, getBoundsInLocal, getBoundsInParent, getCacheHint, getClip, getCursor, getDepthTest, getEffect, getEffectiveNodeOrientation, getEventDispatcher, getId, getInitialCursor, getInputMethodRequests, getLayoutBounds, getLayoutX, getLayoutY, getLocalToParentTransform, getLocalToSceneTransform, getNodeOrientation, getOnContextMenuRequested, getOnDragDetected, getOnDragDone, getOnDragDropped, getOnDragEntered, getOnDragExited, getOnDragOver, getOnInputMethodTextChanged, getOnKeyPressed, getOnKeyReleased, getOnKeyTyped, getOnMouseClicked, getOnMouseDragEntered, getOnMouseDragExited, getOnMouseDragged, getOnMouseDragOver, getOnMouseDragReleased, getOnMouseEntered, getOnMouseExited, getOnMouseMoved, getOnMousePressed, getOnMouseReleased, getOnRotate, getOnRotationFinished, getOnRotationStarted, getOnScroll, getOnScrollFinished, getOnScrollStarted, getOnSwipeDown, getOnSwipeLeft, getOnSwipeRight, getOnSwipeUp, getOnTouchMoved, getOnTouchPressed, getOnTouchReleased, getOnTouchStationary, getOnZoom, getOnZoomFinished, getOnZoomStarted, getOpacity, getParent, getProperties, getPseudoClassStates, getRotate, getRotationAxis, getScaleX, getScaleY, getScaleZ, getScene, getStyle, getStyleableParent, getStyleClass, getTransforms, getTranslateX, getTranslateY, getTranslateZ, getTypeSelector, getUserData, getViewOrder, hasProperties, hoverProperty, idProperty, inputMethodRequestsProperty, intersects, intersects, isCache, isDisable, isDisabled, isFocused, isFocusTraversable, isHover, isManaged, isMouseTransparent, isPickOnBounds, isPressed, isVisible, layoutBoundsProperty, layoutXProperty, layoutYProperty, localToParent, localToParent, localToParent, localToParent, localToParent, localToParentTransformProperty, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToSceneTransformProperty, localToScreen, localToScreen, localToScreen, localToScreen, localToScreen, lookupAll, managedProperty, mouseTransparentProperty, nodeOrientationProperty, notifyAccessibleAttributeChanged, onContextMenuRequestedProperty, onDragDetectedProperty, onDragDoneProperty, onDragDroppedProperty, onDragEnteredProperty, onDragExitedProperty, onDragOverProperty, onInputMethodTextChangedProperty, onKeyPressedProperty, onKeyReleasedProperty, onKeyTypedProperty, onMouseClickedProperty, onMouseDragEnteredProperty, onMouseDragExitedProperty, onMouseDraggedProperty, onMouseDragOverProperty, onMouseDragReleasedProperty, onMouseEnteredProperty, onMouseExitedProperty, onMouseMovedProperty, onMousePressedProperty, onMouseReleasedProperty, onRotateProperty, onRotationFinishedProperty, onRotationStartedProperty, onScrollFinishedProperty, onScrollProperty, onScrollStartedProperty, onSwipeDownProperty, onSwipeLeftProperty, onSwipeRightProperty, onSwipeUpProperty, onTouchMovedProperty, onTouchPressedProperty, onTouchReleasedProperty, onTouchStationaryProperty, onZoomFinishedProperty, onZoomProperty, onZoomStartedProperty, opacityProperty, parentProperty, parentToLocal, parentToLocal, parentToLocal, parentToLocal, parentToLocal, pickOnBoundsProperty, pressedProperty, pseudoClassStateChanged, relocate, removeEventFilter, removeEventHandler, requestFocus, resizeRelocate, rotateProperty, rotationAxisProperty, scaleXProperty, scaleYProperty, scaleZProperty, sceneProperty, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, screenToLocal, screenToLocal, screenToLocal, setAccessibleHelp, setAccessibleRole, setAccessibleRoleDescription, setAccessibleText, setBlendMode, setCache, setCacheHint, setClip, setCursor, setDepthTest, setDisable, setDisabled, setEffect, setEventDispatcher, setEventHandler, setFocused, setFocusTraversable, setHover, setId, setInputMethodRequests, setLayoutX, setLayoutY, setManaged, setMouseTransparent, setNodeOrientation, setOnContextMenuRequested, setOnDragDetected, setOnDragDone, setOnDragDropped, setOnDragEntered, setOnDragExited, setOnDragOver, setOnInputMethodTextChanged, setOnKeyPressed, setOnKeyReleased, setOnKeyTyped, setOnMouseClicked, setOnMouseDragEntered, setOnMouseDragExited, setOnMouseDragged, setOnMouseDragOver, setOnMouseDragReleased, setOnMouseEntered, setOnMouseExited, setOnMouseMoved, setOnMousePressed, setOnMouseReleased, setOnRotate, setOnRotationFinished, setOnRotationStarted, setOnScroll, setOnScrollFinished, setOnScrollStarted, setOnSwipeDown, setOnSwipeLeft, setOnSwipeRight, setOnSwipeUp, setOnTouchMoved, setOnTouchPressed, setOnTouchReleased, setOnTouchStationary, setOnZoom, setOnZoomFinished, setOnZoomStarted, setOpacity, setPickOnBounds, setPressed, setRotate, setRotationAxis, setScaleX, setScaleY, setScaleZ, setStyle, setTranslateX, setTranslateY, setTranslateZ, setUserData, setViewOrder, setVisible, snapshot, snapshot, startDragAndDrop, startFullDrag, styleProperty, toBack, toFront, translateXProperty, translateYProperty, translateZProperty, usesMirroring, viewOrderProperty, visibleProperty`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface javafx.css.Styleable

      `getStyleableNode`

- - ### Property Detail

    - #### converter

          public final ObjectProperty<StringConverter<T>> converterProperty

      The `StringConverter` property.
      Returns:
        the `StringConverter` property

  - ### Constructor Detail

    - #### TextFieldTreeCell

          public TextFieldTreeCell()

      Creates a default TextFieldTreeCell with a null converter. Without a `StringConverter` specified, this cell will not be able to accept input from the TextField (as it will not know how to convert this back to the domain object). It is therefore strongly encouraged to not use this constructor unless you intend to set the converter separately.

    - #### TextFieldTreeCell

          public TextFieldTreeCell​(StringConverter<T> converter)

      Creates a TextFieldTreeCell that provides a `TextField` when put into editing mode that allows editing of the cell content. This method will work on any TreeView instance, regardless of its generic type. However, to enable this, a `StringConverter` must be provided that will convert the given String (from what the user typed in) into an instance of type T. This item will then be passed along to the `TreeView.onEditCommitProperty()` callback.
      Parameters:
        `converter` - A `converter` that can convert the given String (from what the user typed in) into an instance of type T.

  - ### Method Detail

    - #### forTreeView

          public static Callback<TreeView<String>,​TreeCell<String>> forTreeView()

      Provides a `TextField` that allows editing of the cell content when the cell is double-clicked, or when `TreeView.edit(javafx.scene.control.TreeItem)` is called. This method will only work on `TreeView` instances which are of type String.
      Returns:
        A `Callback` that can be inserted into the `cell factory property` of a TreeView, that enables textual editing of the content.

    - #### forTreeView

          public static <T> Callback<TreeView<T>,​TreeCell<T>> forTreeView​(StringConverter<T> converter)

      Provides a `TextField` that allows editing of the cell content when the cell is double-clicked, or when `TreeView.edit(javafx.scene.control.TreeItem)` is called. This method will work on any `TreeView` instance, regardless of its generic type. However, to enable this, a `StringConverter` must be provided that will convert the given String (from what the user typed in) into an instance of type T. This item will then be passed along to the `TreeView.onEditCommitProperty()` callback.
      Type Parameters:
        `T` - The type of the elements contained within the TreeView
      Parameters:
        `converter` - A `StringConverter` that can convert the given String (from what the user typed in) into an instance of type T.
      Returns:
        A `Callback` that can be inserted into the `cell factory property` of a TreeView, that enables textual editing of the content.

    - #### converterProperty

          public final ObjectProperty<StringConverter<T>> converterProperty()

      The `StringConverter` property.
      Returns:
        the `StringConverter` property

    - #### setConverter

          public final void setConverter​(StringConverter<T> value)

      Sets the `StringConverter` to be used in this cell.
      Parameters:
        `value` - the `StringConverter` to be used in this cell

    - #### getConverter

          public final StringConverter<T> getConverter()

      Returns the `StringConverter` used in this cell.
      Returns:
        the `StringConverter` used in this cell

    - #### startEdit

          public void startEdit()

      Call this function to transition from a non-editing state into an editing state, if the cell is editable. If this cell is already in an editing state, it will stay in it.
      Overrides:
        `startEdit` in class `TreeCell<T>`

    - #### cancelEdit

          public void cancelEdit()

      Call this function to transition from an editing state into a non-editing state, without saving any user input.
      Overrides:
        `cancelEdit` in class `TreeCell<T>`

    - #### updateItem

          public void updateItem​(T item,
                                 boolean empty)

      The updateItem method should not be called by developers, but it is the best method for developers to override to allow for them to customise the visuals of the cell. To clarify, developers should never call this method in their code (they should leave it up to the UI control, such as the `ListView` control) to call this method. However, the purpose of having the updateItem method is so that developers, when specifying custom cell factories (again, like the ListView `cell factory`), the updateItem method can be overridden to allow for complete customisation of the cell.

      It is very important that subclasses of Cell override the updateItem method properly, as failure to do so will lead to issues such as blank cells or cells with unexpected content appearing within them. Here is an example of how to properly override the updateItem method:

           protected void updateItem(T item, boolean empty) {
               super.updateItem(item, empty);

               if (empty || item == null) {
                   setText(null);
                   setGraphic(null);
               } else {
                   setText(item.toString());
               }
           }

      Note in this code sample two important points:

      1. We call the super.updateItem(T, boolean) method. If this is not done, the item and empty properties are not correctly set, and you are likely to end up with graphical issues.
      2. We test for the `empty` condition, and if true, we set the text and graphic properties to null. If we do not do this, it is almost guaranteed that end users will see graphical artifacts in cells unexpectedly.
      Parameters:
        `item` - The new item for the cell.
        `empty` - whether or not this cell represents data from the list. If it is empty, then it does not represent any domain data, but is a cell being used to render an "empty" row.